module gw_gao(
    Encoder_sop_in,
    Encoder_eop_in,
    Encoder_inpvalid,
    \din[7] ,
    \din[6] ,
    \din[5] ,
    \din[4] ,
    \din[3] ,
    \din[2] ,
    \din[1] ,
    \din[0] ,
    \BCH_Encoder_Top/sop_out ,
    \BCH_Encoder_Top/eop_out ,
    \BCH_Encoder_Top/outvalid ,
    \BCH_Encoder_Top/data_out[7] ,
    \BCH_Encoder_Top/data_out[6] ,
    \BCH_Encoder_Top/data_out[5] ,
    \BCH_Encoder_Top/data_out[4] ,
    \BCH_Encoder_Top/data_out[3] ,
    \BCH_Encoder_Top/data_out[2] ,
    \BCH_Encoder_Top/data_out[1] ,
    \BCH_Encoder_Top/data_out[0] ,
    SYM_CLK,
    tms_pad_i,
    tck_pad_i,
    tdi_pad_i,
    tdo_pad_o
);

input Encoder_sop_in;
input Encoder_eop_in;
input Encoder_inpvalid;
input \din[7] ;
input \din[6] ;
input \din[5] ;
input \din[4] ;
input \din[3] ;
input \din[2] ;
input \din[1] ;
input \din[0] ;
input \BCH_Encoder_Top/sop_out ;
input \BCH_Encoder_Top/eop_out ;
input \BCH_Encoder_Top/outvalid ;
input \BCH_Encoder_Top/data_out[7] ;
input \BCH_Encoder_Top/data_out[6] ;
input \BCH_Encoder_Top/data_out[5] ;
input \BCH_Encoder_Top/data_out[4] ;
input \BCH_Encoder_Top/data_out[3] ;
input \BCH_Encoder_Top/data_out[2] ;
input \BCH_Encoder_Top/data_out[1] ;
input \BCH_Encoder_Top/data_out[0] ;
input SYM_CLK;
input tms_pad_i;
input tck_pad_i;
input tdi_pad_i;
output tdo_pad_o;

wire Encoder_sop_in;
wire Encoder_eop_in;
wire Encoder_inpvalid;
wire \din[7] ;
wire \din[6] ;
wire \din[5] ;
wire \din[4] ;
wire \din[3] ;
wire \din[2] ;
wire \din[1] ;
wire \din[0] ;
wire \BCH_Encoder_Top/sop_out ;
wire \BCH_Encoder_Top/eop_out ;
wire \BCH_Encoder_Top/outvalid ;
wire \BCH_Encoder_Top/data_out[7] ;
wire \BCH_Encoder_Top/data_out[6] ;
wire \BCH_Encoder_Top/data_out[5] ;
wire \BCH_Encoder_Top/data_out[4] ;
wire \BCH_Encoder_Top/data_out[3] ;
wire \BCH_Encoder_Top/data_out[2] ;
wire \BCH_Encoder_Top/data_out[1] ;
wire \BCH_Encoder_Top/data_out[0] ;
wire SYM_CLK;
wire tms_pad_i;
wire tck_pad_i;
wire tdi_pad_i;
wire tdo_pad_o;
wire tms_i_c;
wire tck_i_c;
wire tdi_i_c;
wire tdo_o_c;
wire [9:0] control0;
wire gao_jtag_tck;
wire gao_jtag_reset;
wire run_test_idle_er1;
wire run_test_idle_er2;
wire shift_dr_capture_dr;
wire update_dr;
wire pause_dr;
wire enable_er1;
wire enable_er2;
wire gao_jtag_tdi;
wire tdo_er1;

IBUF tms_ibuf (
    .I(tms_pad_i),
    .O(tms_i_c)
);

IBUF tck_ibuf (
    .I(tck_pad_i),
    .O(tck_i_c)
);

IBUF tdi_ibuf (
    .I(tdi_pad_i),
    .O(tdi_i_c)
);

OBUF tdo_obuf (
    .I(tdo_o_c),
    .O(tdo_pad_o)
);

GW_JTAG  u_gw_jtag(
    .tms_pad_i(tms_i_c),
    .tck_pad_i(tck_i_c),
    .tdi_pad_i(tdi_i_c),
    .tdo_pad_o(tdo_o_c),
    .tck_o(gao_jtag_tck),
    .test_logic_reset_o(gao_jtag_reset),
    .run_test_idle_er1_o(run_test_idle_er1),
    .run_test_idle_er2_o(run_test_idle_er2),
    .shift_dr_capture_dr_o(shift_dr_capture_dr),
    .update_dr_o(update_dr),
    .pause_dr_o(pause_dr),
    .enable_er1_o(enable_er1),
    .enable_er2_o(enable_er2),
    .tdi_o(gao_jtag_tdi),
    .tdo_er1_i(tdo_er1),
    .tdo_er2_i(1'b0)
);

gw_con_top  u_icon_top(
    .tck_i(gao_jtag_tck),
    .tdi_i(gao_jtag_tdi),
    .tdo_o(tdo_er1),
    .rst_i(gao_jtag_reset),
    .control0(control0[9:0]),
    .enable_i(enable_er1),
    .shift_dr_capture_dr_i(shift_dr_capture_dr),
    .update_dr_i(update_dr)
);

ao_top_0  u_la0_top(
    .control(control0[9:0]),
    .trig0_i(\BCH_Encoder_Top/outvalid ),
    .data_i({Encoder_sop_in,Encoder_eop_in,Encoder_inpvalid,\din[7] ,\din[6] ,\din[5] ,\din[4] ,\din[3] ,\din[2] ,\din[1] ,\din[0] ,\BCH_Encoder_Top/sop_out ,\BCH_Encoder_Top/eop_out ,\BCH_Encoder_Top/outvalid ,\BCH_Encoder_Top/data_out[7] ,\BCH_Encoder_Top/data_out[6] ,\BCH_Encoder_Top/data_out[5] ,\BCH_Encoder_Top/data_out[4] ,\BCH_Encoder_Top/data_out[3] ,\BCH_Encoder_Top/data_out[2] ,\BCH_Encoder_Top/data_out[1] ,\BCH_Encoder_Top/data_out[0] }),
    .clk_i(SYM_CLK)
);

endmodule
