//**********************************************************************
// 	Project: 
//	File: BCH_exp.v
// 	Description: test BCH Encoder / Decoder （GW_2A_18）
//	Author: wenxuan
//  Timestamp: 
//----------------------------------------------------------------------
// Code Revision History:
// Ver:		| Author 	| Mod. Date		| Changes Made:
// v1.0.0	|           	| xx/xx/2022	    | Initial version
//**********************************************************************


module BCH_exp(
// --- sym ---
	input    SYM_CLK,
// --- KEY ---
	input    KEY1,

    output Encoder_sop_out,
    output Encoder_eop_out,
    output Encoder_outvalid,
    output [7:0]Encoder_data_out
);

//**********************************************************************
// --- Parameter
//**********************************************************************
    localparam NUM_CYCLE = 1;
//**********************************************************************
// --- Inter Signal Declaration
//**********************************************************************
    wire clk;
    // wire clk_100M;
	wire rstn;
	assign clk = SYM_CLK;
    assign rstn = KEY1;

    reg Encoder_inpvalid;

    reg Encoder_sop_in,Encoder_eop_in;
    reg [3:0] cycle_cnt,cycle_cnt2;
    reg [7:0] din;
    wire Encoder_ready;
//**********************************************************************
// --- Initial
//**********************************************************************
//******Encoder***************//

always@(posedge clk or negedge rstn) begin
    if(!rstn)
        cycle_cnt<=0;
    else 
        cycle_cnt<=cycle_cnt+1;
end

always@(posedge clk or negedge rstn) begin
    if(!rstn)
        din<=0;
    else if (din==8'h80)
        din<=0;
    else if(cycle_cnt==1)
        din<=din+1;
end

always@(posedge clk or negedge rstn) begin
    if(!rstn)
        Encoder_inpvalid<=0;
    else if(cycle_cnt==1)
        Encoder_inpvalid<=1;
    else
        Encoder_inpvalid<=0;
end
always@(posedge clk or negedge rstn) begin
    if(!rstn)
        Encoder_sop_in<=0;
    else if(cycle_cnt==1)
        Encoder_sop_in<=1;
    else 
        Encoder_sop_in<=0;
end
always@(posedge clk or negedge rstn) begin
    if(!rstn)
        Encoder_eop_in<=0;
    else if(cycle_cnt==1)
        Encoder_eop_in<=1;
    else 
        Encoder_eop_in<=0;
end

//**********************************************************************
// --- Module: top 
// --- Description:	top module of project
//**********************************************************************
BCH_Encoder_Top BCH_Encoder_Top(
    .clk        (clk), 
    .rstn       (rstn),
    .sop_in     (Encoder_sop_in),
    .eop_in     (Encoder_eop_in),
    .inpvalid   (Encoder_inpvalid),
    .data_in    (din),
    .sop_out    (Encoder_sop_out),
    .eop_out    (Encoder_eop_out),
    .outvalid   (Encoder_outvalid),
    .data_out   (Encoder_data_out),
    .ready      (Encoder_ready)
    );

	
 
endmodule
